{{
 :     
 :  
 :         optMathParser
}

unit optMathParserLng;

interface

uses
 optConsts;

const
{$IFDEF ENGLISH_LNG}
 //     
 [Generate compiller error]
{$ELSE}
 //      ( )
 S_BUT_FOUND                           = ',   "%s"';
 S_SPECIAL_FXS                         = 'Sum, Prod';
 S_UNLIMITED_ARGS_FXS                  = 'Max, Min';

 S_SPACE_L                             = 'space(8)&';
 S_SPACE_M                             = '&space(8)&';
 S_IF                                  = 'string()' + S_SPACE_M;
 S_THEN                                = ',' + S_SPACE_L + 'string()'    + S_SPACE_M;
 S_ELSE                                = ',' + S_SPACE_L + 'string()' + S_SPACE_M;
 S_AND                                 = S_SPACE_M + 'string()'   + S_SPACE_M;
 S_OR                                  = S_SPACE_M + 'string()' + S_SPACE_M;

 // :
 S_WARNING_HEADER                      = ': : %d; ';
 W_EXPECTED_INDEXED_EXPRESSION         = S_WARNING_HEADER + ',    "%s"    ,  X_i';
 W_REPITED_VAR_INIT                    = S_WARNING_HEADER + '    %s';
 W_TEXT_AFTER_RESULT_IGNORED           = ':       ';
 W_LOCAL_FX_DECLARED_BUT_NOT_USED      = ':   %s(u)  ,   ';
 W_VAR_X_DECLARED_BUT_NOT_USED         = ':   %s   ';
 W_VAR_DECLARED_BUT_NOT_USED           = ':   %s  ,    ';

 // smth. unknown
 E_UNKNOWN_LEXEME_TYPE                 = '    : "%s"';
 E_UNKNOWN_LEXEME_SUB_TYPE             = '    : "%s"';

 // smth. expected:
 E_EXPRESSION_EXPECTED                 = ' ' + S_BUT_FOUND;
 E_EQUAL_SIGN_EXPECTED                 = ' : "="' + S_BUT_FOUND;
 E_LEFT_BRACKET_EXPECTED               = ' : "("' + S_BUT_FOUND;
 E_RIGHT_BRACKET_EXPECTED              = ' : ")"' + S_BUT_FOUND;
 E_COMMA_EXPECTED                      = ' : ","' + S_BUT_FOUND;
 E_COND_OPERATION_EXPECTED             = '  ' + S_BUT_FOUND;
 E_THEN_EXPECTED                       = '   "then"'  + S_BUT_FOUND;
 E_DELIMITER_EXPECTED                  = '  ' + S_BUT_FOUND;
 E_BEFORE_DOTS_COMMA_EXPECTED          = ' "..."  ","' + S_BUT_FOUND;
 E_AFTER_DOTS_COMMA_EXPECTED           = ' "..."  ","' + S_BUT_FOUND;
 E_BEFORE_DOTS_VAR_EXPECTED            = ' "..."  ' + S_BUT_FOUND;
 E_AFTER_DOTS_VAR_EXPECTED             = ' "..."  ' + S_BUT_FOUND;
 E_VALID_INTEGER_EXPECTED              = '   ' + S_BUT_FOUND;
 E_LEFT_PART_EXPECTED                  = '   ' + S_BUT_FOUND;
 E_ARGS_EXPECTED                       = '    : %d,  : %d';
 E_VAR_U_EXPECTED                      = '    "U"' + S_BUT_FOUND;

 // smth. invalid
 E_INVALID_CHAR                        = ' : "%s"';
 E_INVALID_SUB_TYPE                    = '  "%s"    ' + CRLF + E_INTERNAL_ERROR + CRLF + S_ASK_DEVELOPER;
 E_INVALID_VAR_LEXEME                  = '    : "%s"';
 E_INVALID_VAR_INDEX                   = '  : %s %s';
 E_INVALID_BRACKET_SEQUENCE            = '   "(", "|"  ")" ';
 E_INVALID_LEFT_BRACKET_CNT            = '- "("  - ")"  %d';
 E_INVALID_RIGHT_BRACKET_CNT           = '- ")"  - "("  %d';
 E_INVALID_ABS_BRACKET_CNT             = ' - "|",    , ,    "|"';
 E_INAVLID_RIGHT_ABS_BRACKET           = '    ';
 E_UNRECOGNIZED_ABS_BRACKET            = '   ' + CRLF + E_INTERNAL_ERROR + CRLF + S_ASK_DEVELOPER;
 E_INVALID_RANGE_INDEXES               = '  "%s"      "%s",      1';
 E_INVALID_NESTING                     = '    SUM  PROD   ';
 E_INVALID_IX_FROM                     = '    : %s';
 E_INVALID_IX_TO                       = '    : %s';
 E_INVALID_IX_TO_VALUE                 = '%d';
 E_INVALID_VAR_X                       = ' : %s';
 E_INVALID_VAR                         = '  : %s';
 E_INVALID_NUMBER                      = ' : %s';
 E_INVALID_OPERATION                   = '   "%s"';

 // invalid scope of smth.
 E_INVALID_SCOPE_FOR_Xi                = '   : %s' + CRLF + '  -   : ' + S_SPECIAL_FXS;
 E_INVALID_SCOPE_FOR_VAR_LOOP          = '     "i"' + CRLF + '  -   : ' + S_SPECIAL_FXS;
 E_INVALID_SCOPE_FOR_COND_OPERATION    = '     "%s"' + CRLF + '  -   ';
 E_INVALID_SCOPE_FOR_COMMA             = '   ","' + CRLF + '  -      ';
 E_INVALID_SCOPE_FOR_DOTS              = '   "..."' + CRLF + '  -     : ' + S_UNLIMITED_ARGS_FXS;
 E_INVALID_SCOPE_FOR_SPECIAL_FX        = '   "%s"    ';
 E_INVALID_SCOPE_FOR_VAR_U             = '      "U"' + CRLF + '  -     ';
 E_INVALID_LOCAL_FX_SCOPE              = '  "%s"    ' + CRLF + '     "U"';

 // all other errors
 E_LOCAL_FX_REDECLARED                 = '    "%s"';
 E_UNDECLARED_LOCAL_FX                 = '   : "%s"';
 E_NOT_FINALLY_DECLARED_LOCAL_FX       = '   : "%s"';
 E_UNDECLARED_VAR                      = '  : "%s"';
 E_NOT_FINALLY_DECLARED_VAR            = '  : "%s"';
 E_UNDECLARED_VAR_IN_RANGE             = '   : "%s%d"';
 E_NOT_FINALLY_DECLARED_VAR_IN_RANGE   = '   : "%s%d"';
 E_VARS_MUST_HAVE_SAME_NAME            = ' "%s"  "%s"  "..."    ';
 E_VAR_MUST_HAVE_INTEGER_INDEX         = ' "%s"    ';
 E_IX_TO_MUST_BE_LEQ_TO_DIM            = ' : %d      X: %d';
 E_IX_FROM_MUST_BE_LEQ_TO_IX_TO        = ' : %d    : %d';
 E_COUNT_OF_ABS_BRACKETS_MUST_BE_EVEN  = '-   "|"    %d';
 E_UNEXPECTED_END_OF_EXPRESSION        = '  ';
 E_NO_RESULT_FOUND                     = '     ';
 E_EMPTY_BLOCK                         = '  ';

 // failed to do check some rule
 E_FAILED_TO_CHECK_MATH_FX_RULE        = '    "%s"';
 E_FAILED_TO_CHECK_LOCAL_FX_RULE       = '     ';
 E_FAILED_TO_CHECK_LOCAL_FX_USAGE_RULE = '     "%s"';
 E_FAILED_TO_CHECK_VARIABLE_DSC_RULE   = '     ';
 E_FAILED_TO_CHECK_COND_DSC_RULE       = '    ';
 E_FAILED_TO_CHECK_BLOK_RULE           = '    ';
 E_FAILED_TO_CHECK_RESULT_DSC_RULE     = '     ';

 //    "" 
 E_FORMULA_LEXICAL_ANALYSIS_FAILED     = '     ';
 E_FORMULA_SEMANTIC_ANALYSIS_FAILED    = '     ';
 E_FX_CHECK_FAILED                     = '   ';
 E_FX_TO_SRC_CODE_TRANSLATION_FAILED   = '      ';
 E_FAILED_TO_NORMALIZE_FORMULA_TEXT    = '     ';
 E_FX_TO_MATH_EXPR_TRANSLATION_FAILED  = '       "" ';
{$ENDIF}

implementation

end.
